<!DOCTYPE html>
<html>
<head>
  <title>Einführung in R</title>
  <meta charset="utf-8">
  <meta name="description" content="Einführung in R">
  <meta name="author" content="[PD Dr. Oliver Nakoinz](http://oliver.nakoinz.gitlab.io/OliverNakoinz/)">
  <meta name="generator" content="slidify" />
  <meta name="apple-mobile-web-app-capable" content="yes">
  <meta http-equiv="X-UA-Compatible" content="chrome=1">
  <link rel="stylesheet" href="http://slidifylibraries2.googlecode.com/git/inst/libraries/frameworks/io2012/css/default.css" media="all" >
  <link rel="stylesheet" href="http://slidifylibraries2.googlecode.com/git/inst/libraries/frameworks/io2012/css/phone.css" 
    media="only screen and (max-device-width: 480px)" >
  <link rel="stylesheet" href="http://slidifylibraries2.googlecode.com/git/inst/libraries/frameworks/io2012/css/slidify.css" >
  <link rel="stylesheet" href="http://slidifylibraries2.googlecode.com/git/inst/libraries/highlighters/highlight.js/css/tomorrow.css" />
  <base target="_blank"> <!-- This amazingness opens all links in a new tab. -->  
  
  <!-- Grab CDN jQuery, fall back to local if offline -->
  <script src="http://ajax.aspnetcdn.com/ajax/jQuery/jquery-1.7.min.js"></script>
  <script>window.jQuery || document.write('<script src="http://slidifylibraries2.googlecode.com/git/inst/libraries/widgets/quiz/js/jquery.js"><\/script>')</script> 
  <script data-main="http://slidifylibraries2.googlecode.com/git/inst/libraries/frameworks/io2012/js/slides" 
    src="http://slidifylibraries2.googlecode.com/git/inst/libraries/frameworks/io2012/js/require-1.0.8.min.js">
  </script>
  
  

</head>
<body style="opacity: 0">
  <slides class="layout-widescreen">
    
    <!-- LOGO SLIDE -->
        <slide class="title-slide segue nobackground">
  <hgroup class="auto-fadein">
    <h1>Einführung in R</h1>
    <h2></h2>
    <p>[PD Dr. Oliver Nakoinz](http://oliver.nakoinz.gitlab.io/OliverNakoinz/)<br/></p>
  </hgroup>
  <article></article>  
</slide>
    

    <!-- SLIDES -->
    <slide class="" id="slide-1" style="background:;">
  <hgroup>
    <h1>Test</h1>
  </hgroup>
  <article data-timings="">
    <div class="column-left-small">
![](../5figures/icons/iconmonstr-help-3t.png)
</div>

<div class="column-right-big">
Olat: xxx
</div>

<h1>Test, Frage 1:</h1>

<div class="column-left-small">
![](../5figures/icons/iconmonstr-help-3t.png)
</div>

<div class="column-right-big">
Frage 1: 
</div>

<h1>Test, Frage 2:</h1>

<div class="column-left-small">
![](../5figures/icons/iconmonstr-help-3t.png)
</div>

<div class="column-right-big">
Frage 2: 
</div>

<h1>Test, Frage 3:</h1>

<div class="column-left-small">
![](../5figures/icons/iconmonstr-help-3t.png)
</div>

<div class="column-right-big">
Frage 3: 
</div>

<h1>Aufgabe</h1>

<ol>
<li>Richte ein RStudio Projekt ein</li>
<li>Erstelle mit Rstudio ein R-Notebook (= RMarkdowndatei integriert in RStudio)</li>
<li>Gestalte das Dokument als persönliches R-Tutorial. 

<ul>
<li>entscheide über die Inhalte (wähle beispielsweise aus den Präsentieren Inhalten aus udn variiere diese)</li>
<li>Schreibe Erläuterungen die Dir hilfreich sind</li>
<li>Dieses Dokument dient ggf. als Prüfungsleistung</li>
</ul></li>
</ol>

<h1>R als Rechner: Operatoren</h1>

<p>(Teste diese Funktionalität mit einem Code-Block im R-Notebook)</p>

<pre><code class="r">5+3
</code></pre>

<pre><code>## [1] 8
</code></pre>

<pre><code class="r">5-3
</code></pre>

<pre><code>## [1] 2
</code></pre>

<pre><code class="r">5*3
</code></pre>

<pre><code>## [1] 15
</code></pre>

<pre><code class="r">5/3
</code></pre>

<pre><code>## [1] 1.666667
</code></pre>

<pre><code class="r">5^3
</code></pre>

<pre><code>## [1] 125
</code></pre>

<h1>R als Rechner: Operatoren</h1>

<p>(Teste diese Funktionalität mit einem Code-Block im R-Notebook)</p>

<pre><code class="r">4 == 6
</code></pre>

<pre><code>## [1] FALSE
</code></pre>

<pre><code class="r">4 != 6
</code></pre>

<pre><code>## [1] TRUE
</code></pre>

<pre><code class="r">4 &lt; 6
</code></pre>

<pre><code>## [1] TRUE
</code></pre>

<pre><code class="r">4 &gt; 6
</code></pre>

<pre><code>## [1] FALSE
</code></pre>

<pre><code class="r">(4 &lt; 6) | (4 &gt; 6)
</code></pre>

<pre><code>## [1] TRUE
</code></pre>

<pre><code class="r">(4 &lt; 6) &amp; (4 &gt; 6)
</code></pre>

<pre><code>## [1] FALSE
</code></pre>

<h1>R als Rechner: Funktionen</h1>

<p>(Teste diese Funktionalität mit einem einfachen R-Skript)</p>

<pre><code class="r">sqrt(25)
</code></pre>

<pre><code>## [1] 5
</code></pre>

<pre><code class="r">sin(3.14)
</code></pre>

<pre><code>## [1] 0.001592653
</code></pre>

<pre><code class="r">log(25)
</code></pre>

<pre><code>## [1] 3.218876
</code></pre>

<pre><code class="r">log10(25)
</code></pre>

<pre><code>## [1] 1.39794
</code></pre>

<pre><code class="r">abs(-345.3356)
</code></pre>

<pre><code>## [1] 345.3356
</code></pre>

<pre><code class="r">round(2.43135)
</code></pre>

<pre><code>## [1] 2
</code></pre>

<pre><code class="r">ceiling(2.5)
</code></pre>

<pre><code>## [1] 3
</code></pre>

<pre><code class="r">floor(2.5)
</code></pre>

<pre><code>## [1] 2
</code></pre>

<h1>Code analysieren</h1>

<p><img src="../5figures/codeInterpret_v01.png" alt=""></p>

<h1>R als Rechner: noch einige Funktionen</h1>

<p>(Teste diese Funktionalität mit einem einfachen R-Skript)</p>

<pre><code class="r">sin(3.14)
sin(3,14)
</code></pre>

<h1>R-Objekte: Variablen</h1>

<pre><code class="r">x &lt;- 5
x
</code></pre>

<pre><code>## [1] 5
</code></pre>

<pre><code class="r">sqrt(x)
</code></pre>

<pre><code>## [1] 2.236068
</code></pre>

<pre><code class="r">y &lt;- 7
5 -&gt; x
</code></pre>

<h1>Arbeitsverzeichnis</h1>

<pre><code class="r">wd_lin &lt;- &quot;/home/xxxx/xxxx&quot;
wd_win &lt;- &quot;D:\\xxx\\xxxx&quot;
# set(wd_lin)
</code></pre>

<p>RStudio Projekte setzen das Arbeitsverzeichnis automatisch. Wird ohne Projekte gearbeitet muss es manuell gesetzt werden</p>

<h1>Datentypen</h1>

<div class="column-left">
- numerical
- logical
- complex
- character
- raw
- date
</div>

<div class="column-right">

```r
22
```

```
## [1] 22
```

```r
TRUE
```

```
## [1] TRUE
```

```r
2i+2
```

```
## [1] 2+2i
```

```r
"Text"
```

```
## [1] "Text"
```

```r
as.raw(65)
```

```
## [1] 41
```

```r
as.Date("2018-11-15")
```

```
## [1] "2018-11-15"
```
</div>

<h1>Datenstrukturen</h1>

<ul>
<li>Vektor</li>
<li>Matrix</li>
<li>Array</li>
<li>DataFrame</li>
<li>Faktor</li>
<li>Liste</li>
</ul>

<h1>Datenstrukturen: Vektoren</h1>

<div class="column-left">
> Ein Vektor enthält eine geordnete Menge von Elementen.

Vektoren werden mit der Funktion `c` definiert


```r
x <- c(3,5,2,2,5,8,5,2)
y <- c(6,7,2,4,5,2,9,1)
```
</div>

<div class="column-right">
![Vektor](../5figures/vector.png)
</div>

<h1>Datenstrukturen: Vektoren</h1>

<div class="column-left">
Vektoren lassen sich mit Hilfe von Sequenzen definieren und mit Funktionen manipulieren.
</div>

<div class="column-right">

```r
z <- seq(1:5)
z2 <- seq(along=y)
z3 <- rep(3,5)
x_sort <- sort(x)
x_rev <- rev(x)
x_revsort <- rev(sort(x))
x_sortdec <- sort(x, decreasing = T)
```

</div>

<h1>Datenstrukturen: Vektoren</h1>

<div class="column-left">
Indizees erlauben Teile von Vektoren (und anderen Strukturen) anzusprechen.
</div>

<div class="column-right">

```r
x[4]
```

```
## [1] 2
```

```r
x[c(2,4)]
```

```
## [1] 5 2
```

```r
x[3:6]
```

```
## [1] 2 2 5 8
```

```r
x[x>4]
```

```
## [1] 5 5 8 5
```
</div>

<h1>Datenstrukturen: Vektoren</h1>

<div class="column-left">
Vektoren lassen sich mit Hilfe von Funktionen auswerten. 
</div>

<div class="column-right">

```r
min(x)
```

```
## [1] 2
```

```r
range(x)
```

```
## [1] 2 8
```

```r
length(x)
```

```
## [1] 8
```
</div>

<h1>Matrizen</h1>

<ul>
<li>zweidimensional</li>
<li>keine Zeilen oder Spaltennamen</li>
</ul>

<pre><code class="r">zx &lt;- matrix(x,2,4)
zy &lt;- matrix(y,2,4)
zx+zy
</code></pre>

<pre><code>##      [,1] [,2] [,3] [,4]
## [1,]    9    4   10   14
## [2,]   12    6   10    3
</code></pre>

<p>Prüfe diesen Zeie zusätzlich in einem R-Skript oder einfach in der Konsole: <em>zx$x</em></p>

<h1>Array</h1>

<ul>
<li>mehrdimensional</li>
<li>Matrixalgebra möglich</li>
</ul>

<pre><code class="r">a &lt;- array(data = 1:12,
dim = c(3, 2, 2) )
a
</code></pre>

<pre><code>## , , 1
## 
##      [,1] [,2]
## [1,]    1    4
## [2,]    2    5
## [3,]    3    6
## 
## , , 2
## 
##      [,1] [,2]
## [1,]    7   10
## [2,]    8   11
## [3,]    9   12
</code></pre>

<h1>Dataframe</h1>

<ul>
<li>Tabelle mit Spalten- und Zeilennamen</li>
</ul>

<pre><code class="r">df &lt;- data.frame(x,y)
df$x
</code></pre>

<pre><code>## [1] 3 5 2 2 5 8 5 2
</code></pre>

<pre><code class="r">df[,1]
</code></pre>

<pre><code>## [1] 3 5 2 2 5 8 5 2
</code></pre>

<pre><code class="r">df[1,]
</code></pre>

<pre><code>##   x y
## 1 3 6
</code></pre>

<pre><code class="r">which(x == 2)
</code></pre>

<pre><code>## [1] 3 4 8
</code></pre>

<h1>Faktoren</h1>

<ul>
<li>nominale Variablen werden zahlencodiert</li>
</ul>

<pre><code class="r">f &lt;- factor (c(&quot;Nicole&quot;, &quot;Sabire&quot;,
&quot;Clemens&quot;, &quot;Jos&quot;, &quot;Nicole&quot;))
f
</code></pre>

<pre><code>## [1] Nicole  Sabire  Clemens Jos     Nicole 
## Levels: Clemens Jos Nicole Sabire
</code></pre>

<pre><code class="r">unclass(f)
</code></pre>

<pre><code>## [1] 3 4 1 2 3
## attr(,&quot;levels&quot;)
## [1] &quot;Clemens&quot; &quot;Jos&quot;     &quot;Nicole&quot;  &quot;Sabire&quot;
</code></pre>

<pre><code class="r">levels(f)
</code></pre>

<pre><code>## [1] &quot;Clemens&quot; &quot;Jos&quot;     &quot;Nicole&quot;  &quot;Sabire&quot;
</code></pre>

<h1>Listen</h1>

<ul>
<li>Container für alles mögliche</li>
<li>Doppelklammer index</li>
</ul>

<pre><code class="r">l &lt;- list(c(&quot;Nicole&quot;, &quot;Sabire&quot;,&quot;Clemens&quot;, &quot;Jos&quot;), as.Date(&quot;2018-11-15&quot;), x)
l[[1]][2]
</code></pre>

<pre><code>## [1] &quot;Sabire&quot;
</code></pre>

<h1>Funktionen</h1>

<p>Funktionen bündeln Code zu Algorithmen die mit einer Codezeile aufgerufen werden können. Dies kann neben R Code auch beispielswiese C++ Code sein. </p>

<p>Funktionen werden in Base R oder in Paketen geliefert und können auch selbst definiert werden.</p>

<pre><code class="r">sin(3)
</code></pre>

<pre><code>## [1] 0.14112
</code></pre>

<pre><code class="r">mean(x)
</code></pre>

<pre><code>## [1] 4
</code></pre>

<pre><code class="r">rbind(x,y)
</code></pre>

<pre><code>##   [,1] [,2] [,3] [,4] [,5] [,6] [,7] [,8]
## x    3    5    2    2    5    8    5    2
## y    6    7    2    4    5    2    9    1
</code></pre>

<pre><code class="r">cbind(x,y)
</code></pre>

<pre><code>##      x y
## [1,] 3 6
## [2,] 5 7
## [3,] 2 2
## [4,] 2 4
## [5,] 5 5
## [6,] 8 2
## [7,] 5 9
## [8,] 2 1
</code></pre>

<pre><code class="r">rnorm(5, mean=7, sd=1)
</code></pre>

<pre><code>## [1] 6.869443 5.514427 8.855633 7.989541 5.893280
</code></pre>

<h1>Die wichtigsten Funktionen in R</h1>

<div class="column-left-small">
![](../5figures/icons/iconmonstr-lifebuoy-3.png)
</div>

<div class="column-right-big">

```r
help(sin)
?rbind
# shortcut for 'help()'
??read
summary(x)
```

```
##    Min. 1st Qu.  Median    Mean 3rd Qu.    Max. 
##       2       2       4       4       5       8
```

```r
str(x)
```

```
##  num [1:8] 3 5 2 2 5 8 5 2
```

```r
ls()
```

```
##  [1] "a"         "df"        "f"         "l"         "wd_lin"   
##  [6] "wd_win"    "x"         "x_rev"     "x_revsort" "x_sort"   
## [11] "x_sortdec" "y"         "z"         "z2"        "z3"       
## [16] "zx"        "zy"
```

```r
dir()
```

```
## [1] "B0_Rintro1.html"          "B0_Rintro1.Rmd"          
## [3] "B0_Rintro2.Rmd"           "PresentationExample.html"
## [5] "PresentationExample.Rmd"  "slidy_xxxtemplate.Rmd"   
## [7] "stycss"
```
</div>

<h1>Übung</h1>

<div class="column-left-small">
![](../5figures/icons/iconmonstr-time-15.png)
</div>

<div class="column-right-big">
1. xxxxx
2. xxxxxxx
3. xxxxxxxxxxx
</div>

<h1>xxxxxxxxxxx</h1>

  </article>
  <!-- Presenter Notes -->
</slide>

    <slide class="backdrop"></slide>
  </slides>
  <div class="pagination pagination-small" id='io2012-ptoc' style="display:none;">
    <ul>
      <li>
      <a href="#" target="_self" rel='tooltip' 
        data-slide=1 title='Test'>
         1
      </a>
    </li>
  </ul>
  </div>  <!--[if IE]>
    <script 
      src="http://ajax.googleapis.com/ajax/libs/chrome-frame/1/CFInstall.min.js">  
    </script>
    <script>CFInstall.check({mode: 'overlay'});</script>
  <![endif]-->
</body>
  <!-- Load Javascripts for Widgets -->
  
  <!-- LOAD HIGHLIGHTER JS FILES -->
  <script src="http://slidifylibraries2.googlecode.com/git/inst/libraries/highlighters/highlight.js/highlight.pack.js"></script>
  <script>hljs.initHighlightingOnLoad();</script>
  <!-- DONE LOADING HIGHLIGHTER JS FILES -->
   
  </html>